﻿Public Class NumericTextBox
    Inherits TextBox

    Public Shared Shadows ReadOnly IsEnabledProperty As DependencyProperty = DependencyProperty.RegisterAttached("IsEnabled", GetType(Boolean), GetType(NumericTextBox), New PropertyMetadata(AddressOf PropertyChanged))

    Private Shared Sub PropertyChanged(ByVal dependencyObject As DependencyObject, ByVal dependencyPropertyChangedEventArgs As DependencyPropertyChangedEventArgs)
        Dim textBox As TextBox = CType(dependencyObject, TextBox)
        AddHandler textBox.PreviewTextInput, AddressOf PreviewTextInput
    End Sub

    Private Shared Shadows Sub PreviewTextInput(ByVal sender As Object, ByVal e As Windows.Input.TextCompositionEventArgs)
        If GetIsEnabled(CType(sender, TextBox)) Then
            For Each charItem As Char In e.Text
                If Not Char.IsNumber(charItem) Then
                    e.Handled = True
                End If
            Next
        End If
    End Sub

    Public Shared Function GetIsEnabled(ByVal textBox As TextBox) As Boolean
        Return CBool(textBox.GetValue(IsEnabledProperty))
    End Function

    Public Shared Sub SetIsEnabled(ByVal textBox As TextBox, ByVal isEnabled As Boolean)
        textBox.SetValue(IsEnabledProperty, isEnabled)
    End Sub
End Class