﻿Imports Model

Namespace Workspaces
    Public Class MainWorkspaceVm
        Inherits ViewModelBase

        Public Sub New()
            If Not IsInDesignMode Then
                'DB initialisieren und wenn nötig Default-Daten schreiben
                Using db As New OrdersContext.OrdersDbContext
                    db.Database.CreateIfNotExists()
                    If Not db.Orders.Any Then
                        db.WorkCenters.Add(New WorkCenter("WorkCenter 1", 5))
                        db.WorkCenters.Add(New WorkCenter("WorkCenter 2", 10))
                        db.WorkCenters.Add(New WorkCenter("WorkCenter 3", 12))
                        db.WorkCenters.Add(New WorkCenter("WorkCenter 4", 3))
                        db.SaveChanges()
                        Dim answere As New Answer() With {.AnswerText = "Antworttext", .ContactName = "Neue Kontakt", .RequestDate = DateTime.Now}
                        Dim answereList As New List(Of Answer) : answereList.Add(answere)
                        db.Orders.Add(New Order() With {.ConfirmationDate = DateTime.Now, .ArticleNr = 12345, .Description = "Testartikel", .Remarks = "Beschreibung" _
                                               , .Answers = answereList, .OrderNr = 521145, .Quantity = 235, .CurrentWorkCenter = db.WorkCenters.First})

                        db.SaveChanges()
                    End If
                End Using
            End If
            StatusBarVm = New StatusVm
            OrdersVm = New UrgencyListVm(StatusBarVm)

        End Sub


        Private _statusBarVm As StatusVm
        Public Property StatusBarVm() As StatusVm
            Get
                Return _statusBarVm
            End Get
            Set(ByVal value As StatusVm)
                _statusBarVm = value
                RaisePropertyChanged()
            End Set
        End Property


        Private _ordersVm As UrgencyListVm
        Public Property OrdersVm() As UrgencyListVm
            Get
                Return _ordersVm
            End Get
            Set(ByVal value As UrgencyListVm)
                _ordersVm = value
                RaisePropertyChanged()
            End Set
        End Property




    End Class
End Namespace